import ResizeObserver from 'resize-observer-polyfill';
import 'whatwg-fetch';
import './mocks/index';
import React from 'react';
import { WedaApp as _WedaApp } from '../index';

const noop = () => {};

Object.defineProperty(window, 'scrollTo', { value: noop, writable: true });
Object.defineProperty(window, 'matchMedia', {
  writable: true,
  value: jest.fn().mockImplementation((query) => ({
    matches: false,
    media: query,
    onchange: null,
    addListener: jest.fn(), // deprecated
    removeListener: jest.fn(), // deprecated
    addEventListener: jest.fn(),
    removeEventListener: jest.fn(),
    dispatchEvent: jest.fn(),
  })),
});

window.ResizeObserver = ResizeObserver;

export function WedaApp(props) {
  return (
    <_WedaApp
      {...props}
      context={{
        basic: true,
        checkPageAuth(app, appId, $page) {
          return true;
        },
        ...(props as any)?.context,
      }}
    />
  );
}
